#
# spec file for package xorg-x11-Xvnc
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
%define tigervnc 1
%bcond_with Xstatic
%bcond_without dox 

Name:           tigervnc
Version:        1.1.0
Release:        0
License:        GPL-2.0 and MIT
%if %tigervnc
# BuildRequires:  xorg-x11-server-sdk Mesa-devel libopenssl-devel gcc-c++ libjpeg-devel  
BuildRequires:  nasm gcc-c++ pkgconfig(xproto) pkgconfig(x11) pkgconfig(xext) pkgconfig(xtst)
BuildRequires:  autoconf automake libtool binutils-gold
BuildRequires:  xorg-x11-libICE-devel xorg-x11-libSM-devel pkgconfig(libtasn1) pkgconfig(gnutls) libgcrypt-devel libgpg-error-devel pam-devel
%if %{with Xstatic}
BuildRequires:  pkgconfig(fontutil)
BuildRequires:  pkg-config xmlto pkgconfig(pixman-1) >= 0.15.20 pkgconfig(glproto) pkgconfig(gl) pkgconfig(dri)  pkgconfig(openssl)
BuildRequires:  pkgconfig(fixesproto) >= 4.1 pkgconfig(damageproto) >= 1.1 pkgconfig(xcmiscproto) >= 1.2.0 pkgconfig(xtrans) >= 1.2.2 
BuildRequires:  pkgconfig(bigreqsproto) >= 1.1.0 pkgconfig(xproto)  >= 7.0.17 pkgconfig(randrproto) >= 1.2.99.3 pkgconfig(renderproto) >= 0.11 
BuildRequires:  pkgconfig(xextproto) >= 7.0.99.3 pkgconfig(inputproto)  >= 1.9.99.902 pkgconfig(kbproto) >= 1.0.3 pkgconfig(fontsproto)
BuildRequires:  pkgconfig(videoproto) pkgconfig(compositeproto) >= 0.4 pkgconfig(recordproto) >= 1.13.99.1 pkgconfig(scrnsaverproto) >= 1.1 
BuildRequires:  pkgconfig(resourceproto) pkgconfig(xineramaproto) pkgconfig(xkbfile) pkgconfig(xau) pkgconfig(xdmcp) pkgconfig(xfont) >= 1.4.2
BuildRequires:  pkgconfig(pciaccess) >= 0.8.0 
%endif %{nil Xstatic}
%if %{with dox}
BuildRequires:  texlive-latex 
%endif %{nil with dox}
URL:        http://sourceforge.net/apps/mediawiki/tigervnc/
%else
Requires:       x11vnc
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Group:          System/X11/Servers/XF86_4
%if %tigervnc
Summary:        A high-performance, platform-neutral implementation of VNC
# _____________*_________*_________*_________*_________*_________*_________*
%else
Summary:        Xvnc wrapper script which makes use of Xvfb/x11vnc
%endif
%if %tigervnc
Source1:        http://downloads.sf.net/tigervnc/%name-%version.tar.gz
%if %{with Xstatic}
Source2:        xorg-server-1.9.3.tar.bz2
Patch:          xorg-server-xdmcp.patch
Patch3:  xorg-bug38185.patch
%endif
Patch1:  tigervnc-sf3492352.diff
Patch2:  tigervnc-sf3492503.patch
Patch4:  tigervnc-sf3493012.patch
Patch5:  tigervnc-sf3495623.patch
%else
Source0:        Xvnc.pl
%endif

%description
%if %tigervnc
TigerVNC is a high-performance, platform-neutral implementation of VNC (Virtual Network Computing), 
a client/server application that allows users to launch and interact with graphical applications on remote machines. 
TigerVNC provides the levels of performance necessary to run 3D and video applications;
it attempts to maintain a common look and feel and re-use components, where possible, across the various platforms that it supports. 
TigerVNC also provides extensions for advanced authentication methods and TLS encryption. 
%else
This is a wrapper script, which makes use of Xvfb/x11vnc to implement
a Xvnc server.
%endif

%prep
%if %tigervnc
%setup -T -n %{name}-%{version}/unix/xserver -b1 \
%if %{with Xstatic}
-b2
cp -r -t. ../../../xorg-server-*/*
patch -p1 < ../xserver19.patch
%patch -p2
%patch3 -p1
%endif

cd ../..
%patch1 -p1
%patch2 -p1
%patch4 -p1
%patch5 -p1
cd doc
mv ft-protocol-problems.txt ft-protocol-problems.eml
%endif

%define xcflags -include $PWD/deprec.h -fuse-linker-plugin
%build
%if %tigervnc
pushd ../..
%if %{with dox}
cd doc
for s in rfbtight
do while [[ ! -r "$s.toc" ]] || grep "^No file .*$s\\.toc" "$s.log" && latex "$s.tex"
do :
done
done
cd ..
%endif %{nil with dox}
autoreconf -fi
echo>deprec.h '#ifdef __cplusplus
#define CDECL118 "C"
#else
#define CDECL118
#endif
extern CDECL118 struct hostent *gethostbyname (const char *__name) __attribute__ ((deprecated));
#undef __DATE__
#undef __TIME__
#define __DATE__ "(rpm -qif $0)"
#define __TIME__ __DATE__

'
%configure --disable-static --with-system-jpeg --with-system-zlib \
CFLAGS="$CFLAGS %{xcflags}" CXXFLAGS="$CXXFLAGS %{xcflags}"
make %{?_smp_mflags}
%if %{with Xstatic}
popd
: ./autogen.sh
autoreconf -fiv -Werror
%configure --disable-xvfb --disable-xnest --disable-xorg --disable-dmx \
	   --disable-xwin --disable-xephyr --disable-kdrive --with-pic \
	   --disable-static --disable-xinerama \
	   --disable-composite \
	   --with-xkb-path="/usr/share/X11/xkb" \
	   --with-xkb-output="/var/lib/xkb/compiled" \
	   --disable-dri2 \
	   --enable-glx \
	   --disable-config-dbus \
	   --disable-config-hal \
	   --disable-config-udev \
	   --without-dtrace \
           --with-fontrootdir=/usr/share/fonts
%make %{?_smp_mflags}
%endif %{nil with Xstatic}
%endif %{nil tigervnc}

%install
%if %tigervnc
cd ../..
%makeinstall 
%else %{nil tigervnc}
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 755 $RPM_SOURCE_DIR/Xvnc.pl  $RPM_BUILD_ROOT/usr/bin/Xvnc
%endif %{nil tigervnc}
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/SuSEfirewall2.d/services
cat > $RPM_BUILD_ROOT/etc/sysconfig/SuSEfirewall2.d/services/%{name} << EOF
## Name: VNC Server
## Description: Opens ports for VNC Server
TCP="5801 5901"
EOF
%find_lang '%{name}'

%files -f ../../%{name}.lang
%defattr(-,root,root)
%config /etc/sysconfig/SuSEfirewall2.d/services/%{name}
%{_bindir}/*
%if %tigervnc
%doc %{_mandir}/man1/*
%if %{with Xstatic}
%exclude %{_mandir}/man1/Xserver.1*
%exclude /usr/%{_lib}/xorg/protocol.txt
%exclude /usr/%{_lib}/xorg/modules/extensions/libvnc.la
%exclude /usr/%{_lib}/xorg/modules/extensions/libvnc.so
%exclude /var/lib/xkb/compiled/README.compiled
%endif %{nil Xstatic}
%exclude /usr/lib/debug/*
%exclude /usr/lib/debug/.*
%exclude /usr/src/debug
%endif
%if %{with Xstatic}
%doc COPYING 
%endif %{nil with Xstatic}
%doc ../../README.txt ../../LICENCE.TXT 
%doc ../../doc/ft-protocol-problems.eml ../../doc/realvnc-internals.txt ../../doc/registered-codes.txt 
%if %{with dox}
%doc ../../doc/rfbtight.dvi 
%else %{nil with dox}
%doc ../../doc/rfbtight.tex 
%endif %{nil with dox}

%changelog
